/*
DL2 Monitor: ./pa/icmp.h
Copyright (C) 2002, Rolf Jger, Ulm (Germany)

See the file README for information on usage and redistribution
of this source code file, and for a DISCLAIMER OF ALL WARRANTIES.
*/

/*----------------------------------------------------------------------------
 * Datalink Monitor (icmp): Packet Type icmp (local)
 * creates the Pa_Packet object pa_icmp: see pa.h for details. 
 *
 * Author: Rolf Jger,Ulm
 *----------------------------------------------------------------------------
 * YYYYMMDD  History 
 * 20020410  attention to reserved verbose flags.
 * 20020330  created from scratch
 * $Id: icmp.h,v 1.4 2002/05/01 10:40:22 dv Exp $
 *----------------------------------------------------------------------------
*/
# ifndef __ICMP_H__
# define __ICMP_H__
# include "pa/pa.h"

static Pa_Config pa_icmp_field[] = {
  {"type","MT",0},
  {"code","MC",1},
  {"checksum","CS",2},
  {"data","PD",3},
  {"request-id","RI",4},
  {"sequence-no","SN",5},
  {"gateway-addr","GA",6},
  {"org-datagram","OD",7},
  {"org-timestamp","OT",8},
  {"rcv-timestamp","RT",9},
  {"trm-timestamp","TT",10},
  {"echo-data","ED",11},
  {"pointer","PP",12},
  {"parameters","",13},
  {NULL,NULL,-1}
};
const Pa_Packet pa_icmp = {"icmp",pa_icmp_field};

# define ICMP_Mcode			0x00000001
# define ICMP_Mtype			0x00000002
# define ICMP_Mchecksum			0x00000004
# define ICMP_Mdata			0x00000008
# define ICMP_Mrequest_id		0x00000010
# define ICMP_Msequence_no		0x00000020
# define ICMP_Mgateway_addr		0x00000040
# define ICMP_Morg_datagram		0x00000080
# define ICMP_Morg_timestamp		0x00000100
# define ICMP_Mrcv_timestamp		0x00000200
# define ICMP_Mtrm_timestamp		0x00000400
# define ICMP_Mecho_data		0x00000800
# define ICMP_Mpointer			0x00001000
# define ICMP_Mparameters		0x00002000
# define ICMP_Mdefault			PA_VMdefault
# define ICMP_Mpacket_length		PA_VMpacket_length

# define ICMP_F(i)			pa_icmp_field[i].oname
# define ICMP_Fcode			ICMP_F(0)
# define ICMP_Ftype			ICMP_F(1)
# define ICMP_Fchecksum			ICMP_F(2)
# define ICMP_Fdata			ICMP_F(3)
# define ICMP_Frequest_id		ICMP_F(4)
# define ICMP_Fsequence_no		ICMP_F(5)
# define ICMP_Fgateway_addr		ICMP_F(6)
# define ICMP_Forg_datagram		ICMP_F(7)
# define ICMP_Forg_timestamp		ICMP_F(8)
# define ICMP_Frcv_timestamp		ICMP_F(9)
# define ICMP_Ftrm_timestamp		ICMP_F(10)
# define ICMP_Fecho_data		ICMP_F(11)
# define ICMP_Fpointer			ICMP_F(12)
# define ICMP_Fparameters		ICMP_F(13)
# define ICMP_Fpacket_length		PA_VFpacket_length
//#undef ICMP_F

# endif /*__ICMP_H__*/
